/* SCCSID: inc/cssmdli.h, dss_cdsa_fwk, fwk_rel3, dss_980403 1.5 4/13/98 10:38:24 */
/* ***************************************************************** *
 * Copyright 1998 International Business Machines Corporation. All   *
 * Rights Reserved.                                                  *
 *                                                                   *
 * Please read this carefully.  Your use of this reference           *
 * implementation of certain of the IETF public-key infrastructure   *
 * specifications ("Software") indicates your acceptance of the      *
 * following.  If you do not agree to the following, do not install  *
 * or use any of the Software.                                       *
 *                                                                   *
 * Permission to use, reproduce, distribute and create derivative    *
 * works from the Software ("Software Derivative Works"), and to     *
 * distribute such Software Derivative Works is hereby granted to    *
 * you by International Business Machines Corporation ("IBM").  This *
 * permission includes a license under the patents of IBM that are   *
 * necessarily infringed by your use of the Software as provided by  *
 * IBM.                                                              *
 *                                                                   *
 * IBM licenses the Software to you on an "AS IS" basis, without     *
 * warranty of any kind.  IBM HEREBY EXPRESSLY DISCLAIMS ALL         *
 * WARRANTIES OR CONDITIONS, EITHER EXPRESS OR IMPLIED, INCLUDING,   *
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR CONDITIONS OF       *
 * MERCHANTABILITY, NON INFRINGEMENT AND FITNESS FOR A PARTICULAR    *
 * PURPOSE.  You are solely responsible for determining the          *
 * appropriateness of using this Software and assume all risks       *
 * associated with the use of this Software, including but not       *
 * limited to the risks of program errors, damage to or loss of      *
 * data, programs or equipment, and unavailability or interruption   *
 * of operations.                                                    *
 *                                                                   *
 * IBM WILL NOT BE LIABLE FOR ANY DIRECT DAMAGES OR FOR ANY SPECIAL, *
 * INCIDENTAL, OR  INDIRECT DAMAGES OR FOR ANY ECONOMIC              *
 * CONSEQUENTIAL DAMAGES (INCLUDING LOST PROFITS OR SAVINGS), EVEN   *
 * IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  IBM  *
 * will not be liable for the loss of, or damage to, your records or *
 * data, or any damages claimed by you based on a third party claim. *
 *                                                                   *
 * IBM wishes to obtain your feedback to assist in improving the     *
 * Software.  You grant IBM a world-wide, royalty-free right to use, *
 * copy, distribute, sublicense and prepare derivative works based   *
 * upon any feedback, including materials, error corrections,        *
 * Software Derivatives, enhancements, suggestions and the like that *
 * you provide to IBM relating to the Software (this does not        *
 * include products for which you charge a royalty and distribute to *
 * IBM under other terms and conditions).                            *
 *                                                                   *
 * You agree to distribute the Software and any Software Derivatives *
 * under a license agreement that: 1) is sufficient to notify all    *
 * licensees of the Software and Software Derivatives that IBM       *
 * assumes no liability for any claim that may arise regarding the   *
 * Software or Software Derivatives, and 2) that disclaims all       *
 * warranties, both express and implied, from IBM regarding the      *
 * Software and Software Derivatives.  (If you include this          *
 * Agreement with any distribution of the Software or Software       *
 * Derivatives you will have met this requirement.)  You agree that  *
 * you will not delete any copyright notices in the Software.        *
 *                                                                   *
 * This Agreement is the exclusive statement of your rights in the   *
 * Software as provided by IBM.   Except for the rights granted to   *
 * you in the second paragraph above, You are not granted any other  *
 * patent rights, including but not limited to the right to make     *
 * combinations of the Software with products that infringe IBM      *
 * patents. You agree to comply with all applicable laws and         *
 * regulations, including all export and import laws and regulation. *
 * This Agreement is governed by the laws of the State of New York.  *
 * This Agreement supersedes all other communications,               *
 * understandings or agreements we may have had prior to this        *
 * Agreement.                                                        *
 * ***************************************************************** */

/*
 * (C) COPYRIGHT International Business Machines Corp. 1996, 1997
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 *
 * Copyright (c) 1995, 1996, 1997 Intel Corporation. All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 */

#ifndef _CSSMDLI_H
#define _CSSMDLI_H    

#include "cssmtype.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct cssm_spi_dl_funcs {
    CSSM_RETURN (CSSMAPI *Authenticate) (
                      CSSM_DL_DB_HANDLE DLDBHandle,
                      const CSSM_DB_ACCESS_TYPE_PTR AccessRequest,
                      const CSSM_USER_AUTHENTICATION_PTR UserAuthentication);

    CSSM_DB_HANDLE (CSSMAPI *DbOpen) (
                       CSSM_DL_HANDLE DLHandle,
                       const char *DbName,
                       const CSSM_DB_ACCESS_TYPE_PTR AccessRequest,
                       const CSSM_USER_AUTHENTICATION_PTR UserAuthentication,
                       const void *OpenParameters);


    CSSM_RETURN (CSSMAPI *DbClose) (CSSM_DL_DB_HANDLE DLDBHandle);

    CSSM_DB_HANDLE (CSSMAPI *DbCreate) (
                      CSSM_DL_HANDLE DLHandle,
                      const char *DbName,
                      const CSSM_DBINFO_PTR DBInfo,
                      const CSSM_DB_ACCESS_TYPE_PTR AccessRequest,
                      const CSSM_USER_AUTHENTICATION_PTR UserAuthentication,
                      const void *OpenParameters);

    CSSM_RETURN (CSSMAPI *DbDelete) (
                     CSSM_DL_HANDLE DLHandle,
                     const char *DbName,
                     const CSSM_USER_AUTHENTICATION_PTR UserAuthentication);

    CSSM_RETURN (CSSMAPI *DbImport) (
                     CSSM_DL_HANDLE DLHandle,
                     const char *DbDestinationName,
                     const char *DbSourceName,
                     const CSSM_DBINFO_PTR DBInfo,
                     CSSM_BOOL InfoOnly,
                     const CSSM_USER_AUTHENTICATION_PTR UserAuthentication);

    CSSM_RETURN (CSSMAPI *DbExport) (
                     CSSM_DL_HANDLE DLHandle,
                     const char *DbDestinationName,
                     const char *DbSourceName,
                     CSSM_BOOL InfoOnly,
                     const CSSM_USER_AUTHENTICATION_PTR UserAuthentication);

    CSSM_RETURN (CSSMAPI *DbSetRecordParsingFunctions) (
                        CSSM_DL_HANDLE DLHandle,
                        const char* DbName,
                        CSSM_DB_RECORDTYPE RecordType,
                        const CSSM_DB_RECORD_PARSING_FNTABLE_PTR FunctionTable);

    CSSM_DB_RECORD_PARSING_FNTABLE_PTR (CSSMAPI *DbGetRecordParsingFunctions) (
                                            CSSM_DL_HANDLE DLHandle,
                                            const char* DbName, 
                                            CSSM_DB_RECORDTYPE RecordType);

    char * (CSSMAPI *GetDbNameFromHandle) (CSSM_DL_DB_HANDLE DLHandle);

    CSSM_DB_UNIQUE_RECORD_PTR (CSSMAPI *DataInsert) (
                           CSSM_DL_DB_HANDLE DLDBHandle,
                           const CSSM_DB_RECORDTYPE RecordType,
                           const CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes, 
                           const CSSM_DATA_PTR Data);

    CSSM_RETURN (CSSMAPI *DataDelete) (
                       CSSM_DL_DB_HANDLE DLDBHandle,
                       CSSM_DB_RECORDTYPE RecordType,
                       const CSSM_DB_UNIQUE_RECORD_PTR UniqueRecordIdentifier);

    CSSM_DB_UNIQUE_RECORD_PTR (CSSMAPI *DataGetFirst) (
                       CSSM_DL_DB_HANDLE DLDBHandle,
                       const CSSM_QUERY_PTR Query,
                       CSSM_HANDLE_PTR  ResultsHandle,
                       CSSM_BOOL  *EndOfDataStore,
                       CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes,
                       CSSM_DATA_PTR  Data);

    CSSM_DB_UNIQUE_RECORD_PTR (CSSMAPI *DataGetNext) (
                                  CSSM_DL_DB_HANDLE DLDBHandle,
                                  CSSM_HANDLE ResultsHandle,
                                  CSSM_BOOL *EndOfDataStore,
                                  CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes, 
                                  CSSM_DATA_PTR Data);

    CSSM_RETURN (CSSMAPI *DataAbortQuery) (CSSM_DL_DB_HANDLE DLDBHandle,
                                      CSSM_HANDLE ResultsHandle);

    CSSM_RETURN (CSSMAPI *FreeUniqueRecord) (
                                       CSSM_DL_DB_HANDLE DLDBHandle,
                                       CSSM_DB_UNIQUE_RECORD_PTR UniqueRecord);

    void * (CSSMAPI *PassThrough) (CSSM_DL_DB_HANDLE DLHandle, 
                                   uint32 PassThroughId,
                                   const void * InputParams); 
}CSSM_SPI_DL_FUNCS, *CSSM_SPI_DL_FUNCS_PTR;

#ifdef __cplusplus
}
#endif

#endif
